use sercon_base::Backend;

use crate::backends::*;

pub mod backends;

pub trait FiletypeBackend: Backend {
    fn supported_filetypes(&self) -> Vec<String>;
    fn as_backend(&self) -> &dyn Backend;
}

pub fn all() -> Vec<Box<dyn FiletypeBackend>> {
    vec![
        Box::new(BincodeBackend),
        Box::new(CborBackend),
        Box::new(JsonBackend),
        Box::new(NbtBackend),
        Box::new(RonBackend),
        Box::new(SExpressionBackend),
        Box::new(TomlBackend),
        Box::new(XmlBackend),
        Box::new(YamlBackend),
    ]
}
